﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Windows;

namespace SkyShell.Assets
{
    public class IsNullVisibilityConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null || (value is string && string.IsNullOrEmpty((string)value)))
            {
                if (parameter != null && parameter.ToString() == "negate")
                    return Visibility.Visible;
                else
                    return Visibility.Collapsed;
            }
            else
            {
                if (parameter != null && parameter.ToString() == "negate")
                    return Visibility.Collapsed;
                else
                    return Visibility.Visible;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
