﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SkyShell
{
    /// <summary>
    /// Creating a XAML Windows Phone style loading animation
    /// http://instantiate.co.nz/post/Creating-a-XAML-Windows-Phone-style-loading-animation.aspx
    /// 24. August 2011 16:10| By Luke| 94 Comments | In Blog | 
    /// </summary>
    public partial class BusyAnimation : UserControl
    {
        private double OffsetSecondsValue;

        public BusyAnimation()
        {
            InitializeComponent();
        }


        /// <summary>
        /// The number of seconds from the control being loaded that the animation should 

        /// be offset. This defaults to zero, meaning the animation will start as soon as 

        /// the control is loaded.
        /// </summary> 
        public double OffsetSeconds
        {

            get
            {
                return this.OffsetSecondsValue;
            }
            set
            {
                this.OffsetSecondsValue = value;

                this.OffsetKeyFrameKeyTimes();

            }

        }

        /// <summary>

        /// Offsets the four keyframes of the animation with the set offset value. This 
        /// allows rectangles to be visually staggered if more than one are being used together.

        /// </summary>

        private void OffsetKeyFrameKeyTimes()
        {
            TimeSpan offset = TimeSpan.FromSeconds(OffsetSeconds);
            KeyFrame1.KeyTime = KeyFrame1.KeyTime.TimeSpan.Add(offset);
            KeyFrame2.KeyTime = KeyFrame2.KeyTime.TimeSpan.Add(offset);
            KeyFrame3.KeyTime = KeyFrame3.KeyTime.TimeSpan.Add(offset);
            KeyFrame4.KeyTime = KeyFrame4.KeyTime.TimeSpan.Add(offset);
        }


        private void BusyAnimation_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            if (e.WidthChanged)
            {
                KeyFrame2.Value = this.ActualWidth / 3;
                KeyFrame3.Value = KeyFrame2.Value * 2;
                KeyFrame4.Value = this.ActualWidth + 10;
                KeyFrame5.Value = this.ActualWidth + 10;
            }
        }


    }
}
